<template>
  <card title="Список действий">
    <div
      v-for="(record, index) in computedRecords"
      :key="index"
      class="record"
    >
      {{ record }}
    </div>
  </card>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import Card from '@/components/Card.vue';

interface User {
  id: number;
  email: string;
}

interface Record {
  user: User;
  date: string;
  type: string;
  method: string;
  args?: any;
}

interface Data {
  records: Record[];
}

const user1: User = {
  id: 1,
  email: 'kondratenya21@yahoo.com',
};

const user2: User = {
  id: 2,
  email: 'example@mail.com',
};

export default defineComponent({
  name: 'logs',
  components: {
    Card,
  },
  data(): Data {
    return {
      records: [
        {
          user: user1,
          date: '16:32 31.01.2022',
          type: 'keyword',
          method: 'POST',
          args: {
            keyword: 'бастион двери официальный сайт',
          },
        },
        {
          user: user1,
          date: '16:31 31.01.2022',
          type: 'keyword',
          method: 'POST',
          args: {
            keyword: 'входные двери бастион',
          },
        },
        {
          user: user1,
          date: '16:30 31.01.2022',
          type: 'project',
          method: 'POST',
          args: {
            project: 'бастион',
          },
        },
        {
          user: user2,
          date: '15:46 31.01.2022',
          type: 'logout',
          method: 'POST',
        },
        {
          user: user2,
          date: '15:45 31.01.2022',
          type: 'login',
          method: 'POST',
        },
        {
          user: user1,
          date: '15:46 31.01.2022',
          type: 'logout',
          method: 'POST',
        },
        {
          user: user1,
          date: '15:20 31.01.2022',
          type: 'login',
          method: 'POST',
        },
      ],
    };
  },
  computed: {
    computedRecords(): string[] {
      const records = this.records.map(record => this.translateRecord(record));
      return records;
    },
  },
  methods: {
    translateRecord(record: Record): string {
      if (record.method === 'POST') {
        if (record.type === 'login') {
          return `${record.date} Пользователь ${record.user.email} вошел систему`;
        }

        if (record.type === 'logout') {
          return `${record.date} Пользователь ${record.user.email} вышел из системы`;
        }

        if (record.type === 'project') {
          return `${record.date} Пользователь ${record.user.email} создал проект "${record.args.project}"`;
        }

        if (record.type === 'keyword') {
          return `${record.date} Пользователь ${record.user.email} создал проект "${record.args.keyword}"`;
        }
      }

      return '';
    },
  },
});
</script>
<style lang="scss">
.record {
    margin-top: 0.3rem;
}
</style>
